Index: drivers/filesystems/btrfs/dirctrl.c
===================================================================
--- drivers/filesystems/btrfs/dirctrl.c	(révision 75772)
+++ drivers/filesystems/btrfs/dirctrl.c	(copie de travail)
@@ -670,35 +713,35 @@
             }
         }
     }
-    
+
     if (ccb->query_string.Buffer) {
         TRACE("query string = %.*S\n", ccb->query_string.Length / sizeof(WCHAR), ccb->query_string.Buffer);
     }
-    
+
     newoffset = ccb->query_dir_offset;
-    
+
     ExAcquireResourceSharedLite(&fileref->fcb->nonpaged->dir_children_lock, TRUE);
-    
-    Status = next_dir_entry(fileref, &newoffset, &de, &dc, Irp);
-    
+
+    Status = next_dir_entry(fileref, &newoffset, &de, &dc);
+
     if (!NT_SUCCESS(Status)) {
         if (Status == STATUS_NO_MORE_FILES && initial)
             Status = STATUS_NO_SUCH_FILE;
         goto end;
     }
-    
+
     ccb->query_dir_offset = newoffset;
 
-    buf = map_user_buffer(Irp);
-    
+    buf = map_user_buffer(Irp, NormalPagePriority);
+
     if (Irp->MdlAddress && !buf) {
         ERR("MmGetSystemAddressForMdlSafe returned NULL\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     length = IrpSp->Parameters.QueryDirectory.Length;
-    
+
     if (specific_file) {
         BOOL found = FALSE;
         UNICODE_STRING us;
@@ -705,9 +748,9 @@
         LIST_ENTRY* le;
         UINT32 hash;
         UINT8 c;
-        
+
         us.Buffer = NULL;
-        
+
         if (!ccb->case_sensitive) {
             Status = RtlUpcaseUnicodeString(&us, &ccb->query_string, TRUE);
             if (!NT_SUCCESS(Status)) {
@@ -714,33 +757,34 @@
                 ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
                 goto end;
             }
-            
+
             hash = calc_crc32c(0xffffffff, (UINT8*)us.Buffer, us.Length);
         } else
             hash = calc_crc32c(0xffffffff, (UINT8*)ccb->query_string.Buffer, ccb->query_string.Length);
-        
+
         c = hash >> 24;
-        
+
         if (ccb->case_sensitive) {
             if (fileref->fcb->hash_ptrs[c]) {
                 le = fileref->fcb->hash_ptrs[c];
                 while (le != &fileref->fcb->dir_children_hash) {
                     dir_child* dc2 = CONTAINING_RECORD(le, dir_child, list_entry_hash);
-                    
+
                     if (dc2->hash == hash) {
                         if (dc2->name.Length == ccb->query_string.Length && RtlCompareMemory(dc2->name.Buffer, ccb->query_string.Buffer, ccb->query_string.Length) == ccb->query_string.Length) {
                             found = TRUE;
-                            
+
                             de.key = dc2->key;
                             de.name = dc2->name;
                             de.type = dc2->type;
                             de.dir_entry_type = DirEntryType_File;
-                            
+                            de.dc = dc2;
+
                             break;
                         }
                     } else if (dc2->hash > hash)
                         break;
-                    
+
                     le = le->Flink;
                 }
             }
@@ -749,29 +793,30 @@
                 le = fileref->fcb->hash_ptrs_uc[c];
                 while (le != &fileref->fcb->dir_children_hash_uc) {
                     dir_child* dc2 = CONTAINING_RECORD(le, dir_child, list_entry_hash_uc);
-                    
+
                     if (dc2->hash_uc == hash) {
                         if (dc2->name_uc.Length == us.Length && RtlCompareMemory(dc2->name_uc.Buffer, us.Buffer, us.Length) == us.Length) {
                             found = TRUE;
-                            
+
                             de.key = dc2->key;
                             de.name = dc2->name;
                             de.type = dc2->type;
                             de.dir_entry_type = DirEntryType_File;
-                            
+                            de.dc = dc2;
+
                             break;
                         }
                     } else if (dc2->hash_uc > hash)
                         break;
-                    
+
                     le = le->Flink;
                 }
             }
         }
-        
+
         if (us.Buffer)
             ExFreePool(us.Buffer);
-        
+
         if (!found) {
             Status = STATUS_NO_SUCH_FILE;
             goto end;
@@ -779,28 +824,28 @@
     } else if (has_wildcard) {
         while (!FsRtlIsNameInExpression(&ccb->query_string, &de.name, !ccb->case_sensitive, NULL)) {
             newoffset = ccb->query_dir_offset;
-            Status = next_dir_entry(fileref, &newoffset, &de, &dc, Irp);
-            
+            Status = next_dir_entry(fileref, &newoffset, &de, &dc);
+
             if (NT_SUCCESS(Status))
                 ccb->query_dir_offset = newoffset;
             else {
                 if (Status == STATUS_NO_MORE_FILES && initial)
                     Status = STATUS_NO_SUCH_FILE;
-                
+
                 goto end;
             }
         }
     }
-    
+
     TRACE("file(0) = %.*S\n", de.name.Length / sizeof(WCHAR), de.name.Buffer);
     TRACE("offset = %u\n", ccb->query_dir_offset - 1);
 
-    Status = query_dir_item(fcb, fileref, buf, &length, Irp, &de, fcb->subvol);
+    Status = query_dir_item(fcb, ccb, buf, &length, Irp, &de, fcb->subvol);
 
     count = 0;
     if (NT_SUCCESS(Status) && !(IrpSp->Flags & SL_RETURN_SINGLE_ENTRY) && !specific_file) {
         lastitem = (UINT8*)buf;
-        
+
         while (length > 0) {
             switch (IrpSp->Parameters.QueryDirectory.FileInformationClass) {
                 case FileBothDirectoryInformation:
@@ -810,35 +855,35 @@
                 case FileIdFullDirectoryInformation:
                     length -= length % 8;
                     break;
-                    
+
                 case FileNamesInformation:
                     length -= length % 4;
                     break;
-                    
+
                 default:
                     WARN("unhandled file information class %u\n", IrpSp->Parameters.QueryDirectory.FileInformationClass);
                     break;
             }
-            
+
             if (length > 0) {
                 newoffset = ccb->query_dir_offset;
-                Status = next_dir_entry(fileref, &newoffset, &de, &dc, Irp);
+                Status = next_dir_entry(fileref, &newoffset, &de, &dc);
                 if (NT_SUCCESS(Status)) {
                     if (!has_wildcard || FsRtlIsNameInExpression(&ccb->query_string, &de.name, !ccb->case_sensitive, NULL)) {
                         curitem = (UINT8*)buf + IrpSp->Parameters.QueryDirectory.Length - length;
                         count++;
-                        
+
                         TRACE("file(%u) %u = %.*S\n", count, curitem - (UINT8*)buf, de.name.Length / sizeof(WCHAR), de.name.Buffer);
                         TRACE("offset = %u\n", ccb->query_dir_offset - 1);
-                        
-                        status2 = query_dir_item(fcb, fileref, curitem, &length, Irp, &de, fcb->subvol);
-                        
+
+                        status2 = query_dir_item(fcb, ccb, curitem, &length, Irp, &de, fcb->subvol);
+
                         if (NT_SUCCESS(status2)) {
                             ULONG* lastoffset = (ULONG*)lastitem;
-                            
+
                             *lastoffset = (ULONG)(curitem - lastitem);
                             ccb->query_dir_offset = newoffset;
-                            
+
                             lastitem = curitem;
                         } else
                             break;
@@ -847,7 +892,7 @@
                 } else {
                     if (Status == STATUS_NO_MORE_FILES)
                         Status = STATUS_SUCCESS;
-                    
+
                     break;
                 }
             } else
@@ -854,18 +899,18 @@
                 break;
         }
     }
-    
+
     Irp->IoStatus.Information = IrpSp->Parameters.QueryDirectory.Length - length;
-    
+
 end:
     ExReleaseResourceLite(&fileref->fcb->nonpaged->dir_children_lock);
-    
+
 end2:
-    ExReleaseResourceLite(&fcb->Vcb->fcb_lock);
-    ExReleaseResourceLite(&fcb->Vcb->tree_lock);
-    
+    ExReleaseResourceLite(&Vcb->fcb_lock);
+    ExReleaseResourceLite(&Vcb->tree_lock);
+
     TRACE("returning %08x\n", Status);
-    
+
     if (utf8.Buffer)
         ExFreePool(utf8.Buffer);
 
@@ -872,65 +917,86 @@
     return Status;
 }
 
-static NTSTATUS STDCALL notify_change_directory(device_extension* Vcb, PIRP Irp) {
+static NTSTATUS notify_change_directory(device_extension* Vcb, PIRP Irp) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     PFILE_OBJECT FileObject = IrpSp->FileObject;
     fcb* fcb = FileObject->FsContext;
     ccb* ccb = FileObject->FsContext2;
-    file_ref* fileref = ccb->fileref;
+    file_ref* fileref = ccb ? ccb->fileref : NULL;
     NTSTATUS Status;
-    
+
     TRACE("IRP_MN_NOTIFY_CHANGE_DIRECTORY\n");
-    
+
     if (!ccb) {
         ERR("ccb was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (!fileref) {
         ERR("no fileref\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (Irp->RequestorMode == UserMode && !(ccb->access & FILE_LIST_DIRECTORY)) {
         WARN("insufficient privileges\n");
         return STATUS_ACCESS_DENIED;
     }
-    
+
     ExAcquireResourceSharedLite(&fcb->Vcb->tree_lock, TRUE);
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     if (fcb->type != BTRFS_TYPE_DIRECTORY) {
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     // FIXME - raise exception if FCB marked for deletion?
-    
+
     TRACE("%S\n", file_desc(FileObject));
 
     if (ccb->filename.Length == 0) {
-        Status = fileref_get_filename(fileref, &ccb->filename, NULL);
-        if (!NT_SUCCESS(Status)) {
+        ULONG reqlen;
+
+        ccb->filename.MaximumLength = ccb->filename.Length = 0;
+
+        Status = fileref_get_filename(fileref, &ccb->filename, NULL, &reqlen);
+        if (Status == STATUS_BUFFER_OVERFLOW) {
+            ccb->filename.Buffer = ExAllocatePoolWithTag(PagedPool, reqlen, ALLOC_TAG);
+            if (!ccb->filename.Buffer) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto end;
+            }
+
+            ccb->filename.MaximumLength = (UINT16)reqlen;
+
+            Status = fileref_get_filename(fileref, &ccb->filename, NULL, &reqlen);
+            if (!NT_SUCCESS(Status)) {
+                ERR("fileref_get_filename returned %08x\n", Status);
+                goto end;
+            }
+        } else {
             ERR("fileref_get_filename returned %08x\n", Status);
             goto end;
         }
     }
-    
+
     FsRtlNotifyFilterChangeDirectory(Vcb->NotifySync, &Vcb->DirNotifyList, FileObject->FsContext2, (PSTRING)&ccb->filename,
                                      IrpSp->Flags & SL_WATCH_TREE, FALSE, IrpSp->Parameters.NotifyDirectory.CompletionFilter, Irp,
                                      NULL, NULL, NULL);
-    
+
     Status = STATUS_PENDING;
-    
+
 end:
     ExReleaseResourceLite(fcb->Header.Resource);
     ExReleaseResourceLite(&fcb->Vcb->tree_lock);
-    
+
     return Status;
 }
 
-NTSTATUS STDCALL drv_directory_control(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_DIRECTORY_CONTROL)
+_Function_class_(DRIVER_DISPATCH)
+NTSTATUS drv_directory_control(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
     PIO_STACK_LOCATION IrpSp;
     NTSTATUS Status;
     ULONG func;
@@ -937,32 +1003,35 @@
     BOOL top_level;
     device_extension* Vcb = DeviceObject->DeviceExtension;
 
-    TRACE("directory control\n");
-    
     FsRtlEnterFileSystem();
 
+    TRACE("directory control\n");
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_directory_control(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
+
     IrpSp = IoGetCurrentIrpStackLocation(Irp);
-    
+
     Irp->IoStatus.Information = 0;
-    
+
     func = IrpSp->MinorFunction;
-    
+
     switch (func) {
         case IRP_MN_NOTIFY_CHANGE_DIRECTORY:
             Status = notify_change_directory(Vcb, Irp);
             break;
-            
+
         case IRP_MN_QUERY_DIRECTORY:
-            Status = query_directory(DeviceObject, Irp);
+            Status = query_directory(Irp);
             break;
-            
+
         default:
             WARN("unknown minor %u\n", func);
             Status = STATUS_NOT_IMPLEMENTED;
@@ -969,21 +1038,21 @@
             Irp->IoStatus.Status = Status;
             break;
     }
-    
+
     if (Status == STATUS_PENDING)
         goto exit;
-    
+
+end:
     Irp->IoStatus.Status = Status;
 
-//     if (Irp->UserIosb)
-//         *Irp->UserIosb = Irp->IoStatus;
-        
     IoCompleteRequest(Irp, IO_DISK_INCREMENT);
-    
+
 exit:
-    if (top_level) 
+    TRACE("returning %08x\n", Status);
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
 
     return Status;
